"""
AUTHOR
Elisabetta Manduchi

SCOPE
Cross-validation generator to be used in resAdjTPOT. Expects X to contain
indicator columns as generated by the resAdjTpotPreprocessor script.
"""

import numpy as np
import pandas as pd

class resAdjPredefinedSplits:
    def __init__(self, n_splits=5, test_size=None, train_size=None, random_state=None):
        self.n_splits = n_splits

    def split(self, X, y=None, groups=None):
        for i in range(self.n_splits):
            col = 'indicator_' + str(i+1)
            if col not in X.columns:
                raise ValueError('X is missing column ' + col)
            train = np.where(X[col]==0)[0]
            test = np.where(X[col]==1)[0]
            yield train, test

    def get_n_splits(self, X, y, groups=None):
        return self.n_splits
